#ifndef CONGA_H
#define CONGA_H

#include "cluster.h"
#include "ComponentsLoop.h"
  
  /**
  * @class CONGA
  * @brief Cluster Overlapping Newman Girvan Algorithm
  * 
  * Expects java implementation in same directory
  */
 template <typename R>
 class CONGA: public ClusterAlg<R>{
    public:
    
      /**
       * Constructor
       * 	Simple parameter setting.
       * 
       * @param a Algorithm Parameters
       */
    CONGA(string a){
      this->args = a;
      this->dens = new complex_density<bidirected_t>(0);
    };
    
    /**
     * Destructor
     * 	Empty
     */
    ~CONGA(){};
    
    /**
     * Implementation Wrapper 
     * 		Calls implementation on each connected component of network
     */
    void calculate();
    
    /**
     * Actual Implementation
     * 
     * @param component Connected component of network
     * @param instance Clustering algorithm instance
     * @return true
     */    
    static bool CONGAComp(map <lui, map <lui, R> >* component, void* instance);
    
private:
    static int h;/**< @see Constructor*/
};


#endif