#include "COPRA.h"

 /**
  * Implementation for Cluster Overlapping Propagation Algorithm
  */
template <typename R>
void COPRA<R>::calculate(){
  /* Get Graph */
  vector <string> fields;
  map < string, lui >::iterator it_id;
  typename map < lui, map <lui, R> >::iterator it_gr;
  typename map <lui, R>::iterator it_ed;
  
  /*Print the graph out to a temp file*/
  ofstream GrTmpOut("COPRAGraph");
  
  for (it_gr = (this->network).begin(); it_gr != (this->network).end(); it_gr++){
    for (it_ed = it_gr->second.begin(); it_ed != it_gr->second.end(); it_ed++){
      GrTmpOut << it_gr->first << " " << it_ed->first << " " << it_ed->second << endl;
    }
  }
  
  GrTmpOut.close();
  
  /*Call COPRA clustering*/
  /* -w -v param -repeat 10 */
  
  system(("java -cp COPRA/copra.jar COPRA COPRAGraph " + this->args).c_str());
  
  system("rm COPRAGraph");
  
  /*Read in clusters - getting density for each*/
  ifstream clustersin;
  openFile(&clustersin, "best-clusters-COPRAGraph");
  while (fline_tr(&clustersin, &fields, " ")){
    if (fields.size() > 0 && fields[0][0] == '#')
      continue;
    
    set <lui> theCluster;
    
    for (sui t = 0; t < fields.size(); t++){
      theCluster.insert(boost::lexical_cast<lui>(fields[t]));
    }
    
    if (theCluster.size() < 3)
      continue;
    
    if (this->translate)
      this->PrintTranslatedCommunity(&theCluster);
    else
      this->PrintCommunity(&theCluster);
  }
  
  clustersin.close();
}

template void COPRA<double>::calculate();
template void COPRA<int>::calculate();