#include "CliqPerc.h"

/**
 * 	Calculate Clusters in the graph using the Clique Percolation algorithm.
 * 
 * @pre CFinder_commandline installed in directory
 */
template <typename R>
void CliqueCluster<R>::calculate()
{
  /*Print out the network in the correct format*/
  ofstream fout("ClGraph");  
  this->PrintGraph(&fout);
  fout.flush();
  fout.close();
  
 
  /*Cluster the network*/
  system("rm -r ClGraph_files");
  string command ="./CFinder_commandline -i ./ClGraph " + this->args;
  system(command.c_str());

  /*Print out the clusters with added density and size*/
  ifstream clin;
  openFile(&clin, ("ClGraph_files/k=" + ks + "/communities"));
 
  set <lui>::iterator it_cl;
  vector <string> fields;
  while (fline_tr(&clin, &fields, " ")){
    if (strcmp(fields[0].c_str(), "#") == 0 || fields.size() < 4) //Communities must be at least 3 large
      continue;
    set <lui> cluster;
    for (sui i = 1; i < fields.size(); i++){
      cluster.insert(boost::lexical_cast<lui>(fields[i]));
    } 
    if (this->translate)
      this->PrintTranslatedCommunity(&cluster);
    else
      this->PrintCommunity(&cluster);
  }
}

template void CliqueCluster<double>::calculate();
template void CliqueCluster<int>::calculate();