#include "LCOMM.h"

 /**
  * Implementation for Link Communities
  */
template <typename R>
void LCOMM<R>::calculate(){
  /* Get Graph */
  vector <string> fields;
  map < string, lui >::iterator it_id;
  typename map < lui, map <lui, R> >::iterator it_gr;
  typename map <lui, R>::iterator it_ed;
  
  /*Print the graph out to a temp file*/
  ofstream GrTmpOut("LCOMMGraph");
  
  for (it_gr = (this->network).begin(); it_gr != (this->network).end(); it_gr++){
    for (it_ed = it_gr->second.begin(); it_ed != it_gr->second.end(); it_ed++){
      GrTmpOut << it_gr->first << ", " << it_ed->first << ", " << it_ed->second << endl;
    }
  }
  
  GrTmpOut.close();
  
  /*Call LCOMM clustering*/
  
  system(("python LCOMM/link_clustering.py " + this->args + " LCOMMGraph").c_str()); //Make threshold user controlled
  
  /*Read in clusters - getting density for each*/
  ifstream clustersin;
  openFile(&clustersin, "Results.comm2nodes.txt");
  while (fline_tr(&clustersin, &fields, ",")){
    if ((fields.size() > 0 && fields[0][0] == '#') || fields.size() < 4)
      continue;
    
    set <lui> theCluster;
    
    /**The results from LCOMM include the 'Cluster ID' number as the first number on each line:
	  1, [Nodes in Cluster 1]
	  2, [Nodes in Cluster 2] ...
      */
    for (sui t = 1; t < fields.size(); t++){
      theCluster.insert(boost::lexical_cast<lui>(fields[t]));
    }
    
    if (this->translate)
      this->PrintTranslatedCommunity(&theCluster);
    else
      this->PrintCommunity(&theCluster);
  }
  
  clustersin.close();
}


template void LCOMM<double>::calculate();
template void LCOMM<int>::calculate();