/**
 * @file MyTools.h
 * @brief Declarations of helper functions
 * 
 * @see MyTools.cc for explanations
 */

#ifndef MYTOOLS_H
#define MYTOOLS_H

#include <cstdlib>
#include <vector>
#include <limits>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <iostream>
#include <algorithm>
#include <fstream>

#include "boost/tuple/tuple.hpp"
#include "boost/tuple/tuple_comparison.hpp"
#include "boost/tuple/tuple_io.hpp"
#include "boost/algorithm/string.hpp"
#include "boost/lexical_cast.hpp"

using namespace std;
typedef long unsigned int lui;
typedef short unsigned int sui;

bool openFile(ifstream* fin, string filename);
const std::string trim(const std::string& pString,
                       const std::string& pWhitespace = " \n\r");
bool fline_tr(ifstream* fin, vector<string>* fields, string delim = " ");
map < string, vector < string > > getParameters(int argc, char** input);
int lineCount(string filename);
/**
 * @fn void WriteMap(map <T, R>* IDs, string fileOut)
 *
 * Writes a map to a file
 * @param IDs map to output
 * @param fileOut File to print results to
 */
template <typename T, typename R>

void WriteMap(map <T, R>* IDs, string fileOut){
  typename map <T, R>::iterator it_id;
  ofstream fout(fileOut.c_str());
  
  fout << "Original String : ID" << endl;
  
  for (it_id = IDs->begin(); it_id != IDs->end(); it_id++){
    fout << it_id->first << ":" << it_id->second << endl;
  }
}

#endif
