#include "OSLOM.h"
 
 /**
  * Implementation for Order Statistics Local Optimization Method
  */
template <typename R>
void OSLOM<R>::calculate(){
  /*Get Graph*/
  vector <string> fields;
  map < string, lui >::iterator it_id;
  typename map < lui, map <lui, R> >::iterator it_gr;
  typename map <lui, R>::iterator it_ed;
 
  /*Print the graph out to a temp file*/
  ofstream GrTmpOut("OSLOMGraph");
  
  for (it_gr = (this->network).begin(); it_gr != (this->network).end(); it_gr++){
    for (it_ed = it_gr->second.begin(); it_ed != it_gr->second.end(); it_ed++){
      GrTmpOut << it_gr->first << " " << it_ed->first << " " << it_ed->second << endl;
    }
  }
  
  GrTmpOut.close();
  
  /*Call OSLOM clustering*/
  system("rm -r OSLOMGraph_oslo_files");
  
  system(("./OSLOM2/oslom_undir -f OSLOMGraph " + this->args).c_str()); //Make threshold user controlled  
  /*Read in clusters - getting density for each*/
  ifstream clustersin;
  openFile(&clustersin, "OSLOMGraph_oslo_files/tp_without_singletons");
  while (fline_tr(&clustersin, &fields, " ")){
    if (fields.size() > 0 && fields[0].at(0) == '#')
      continue;
    
    set <lui> theCluster;
    
    for (sui t = 0; t < fields.size(); t++){
      theCluster.insert(boost::lexical_cast<lui>(fields[t]));
    }
    
    if (theCluster.size() < 3)
      continue;
    
    if (this->translate)
      this->PrintTranslatedCommunity(&theCluster);
    else
      this->PrintCommunity(&theCluster);
  }
  
  clustersin.close();
}

template void OSLOM<double>::calculate();
template void OSLOM<int>::calculate();