#ifndef RRW_H
#define RRW_H
  
#include "cluster.h"
  /**
  * @class RRW
  * @brief Repeated Random Walks Implementation
  * 
  * Expects java implementation in same directory
  */
 template <typename R>
 class RRW:public ClusterAlg<R>{
    public:
      /**
       * Constructor
       * 
       * 	Set simple parameters.
       * 
       * @param args Algorithm arguments
       */
      RRW(string a){
	this->args = a;
	
	this->dens = new complex_density<bidirected_t>(0);
      };
      
      /**
       *  Destructor
       * 
       *  Empty
       */
      ~RRW(){};
      
      /**
       * Implementation Wrapper
       * 	Calls implementation on each connected component of network
       */
      void calculate();
      
      /**
       * Actual Implementation
       * 
       * @param component Connected component of the network to run the algorithm on
       * @param instance Clustering Algorithm instance
       * 
       * @return true
       */      
      static bool RRWComp(map <lui, map <lui, R> >* component, void* instance);
      
  private:
    static double restart, overlapThreshold, earlyCutoff; /**< @see Constructor*/
    static int min, max;/**< @see Constructor*/
  };

#endif