#include "SLPA.h"

 /**
  * Implementation for Speaker-Listener Label Propagation Algorithm
  */
template <typename R>
void SLPA<R>::calculate()
{
  vector <string> fields;
  map < string, lui >::iterator it_id;
  typename map <lui, map <lui, R> >::iterator it_gr;
  typename map <lui, R>::iterator it_ed;
  
  /*Print the graph out to a temp file*/
  ofstream GrTmpOut("SLPAGraph");
  
  for (it_gr = (this->network).begin(); it_gr != (this->network).end(); it_gr++){
    for (it_ed = it_gr->second.begin(); it_ed != it_gr->second.end(); it_ed++){
      GrTmpOut << it_gr->first << " " << it_ed->first << " " << it_ed->second << endl;
      GrTmpOut << it_ed->first << " " << it_gr->first << " " << it_ed->second << endl;
    }
  }
  
  GrTmpOut.close();
  
  /*Call SLPA clustering*/
  system("rm -r output");
  system("mkdir output");
  system(("java -jar SLPA/SLPAw.jar -i SLPAGraph " + this->args).c_str());
  system("rm SLPAGraph");
  
  /*Read in clusters - getting density for each*/
  ifstream clustersin;
  openFile(&clustersin, ("output/SLPAw_SLPAGraph_run1_r"+threshold+".icpm").c_str());
  while (fline_tr(&clustersin, &fields, " ")){
    set <lui> theCluster;
    
    for (sui t = 0; t < fields.size(); t++){
      theCluster.insert(boost::lexical_cast<lui>(fields[t]));
    }
    
    if (theCluster.size() < 3)
      continue;
  
    if (this->translate)
      this->PrintTranslatedCommunity(&theCluster);
    else
      this->PrintCommunity(&theCluster);
    
  }
  clustersin.close();
}

template void SLPA<double>::calculate();
template void SLPA<int>::calculate();