#ifndef SLPA_H
#define SLPA_H

#include "cluster.h"

/**
  * @class SLPA
  * @brief Speaker-Listener Label Propagation Algorithm
  * 
  * Another java implementation necessary in the directory.
  */
template <typename R>
class SLPA: public ClusterAlg<R>{
  public:
  
    /**
     * Constructor
     * 	Simple parameter setting
     * 
     * @param a Algorithm Arguments
     */
  SLPA(string a){
    this->args = a;
 
    vector <string> aa;
    string extendArg = ("SLPAParam " + this->args);
    boost::split(aa, extendArg, boost::is_any_of(" "));
    
    char** av = new char*[aa.size()];
    for (sui r = 0; r < aa.size();r++){
      av[r] = (char*)(malloc((aa[r].size() + 1) * sizeof(char)));
      strcpy(av[r], aa[r].c_str());
    }
    map <string, vector < string > > subParam = getParameters(aa.size(), av);
    map <string, vector < string > >::iterator it_sub;
    if ((it_sub = subParam.find("r")) != subParam.end()){
      threshold = it_sub->second[0];
    }
    
    this->dens = new complex_density<bidirected_t>(0);
  };
  
  /**
   * Destructor
   * 	Empty
   */
  ~SLPA(){};
  
  /**
   * Implementation
   */
  void calculate();
  
private:
  string threshold, runs, iterations;/**< @see Constructor*/
};

#endif