#ifndef SSDE_H
#define SSDE_H

#include "cluster.h"
#include "ComponentsLoop.h"
 
 /**
  * @class SSDE
  * @brief Sampled Spectral Distance Embedding
  * 
  * "Empire Strikes Back Death Star" situation (Not Fully Operational)  
  */
template <typename R>
class SSDE: public ClusterAlg<R>{
public:
  
  /**
   * Constructor
   * 	Empty
   */
  SSDE(){};
  
  /**
   * Destructor
   * 
   * 	Empty
   */
  ~SSDE(){};
  
  /**
     * Implementation Wrapper 
     * 		Calls implementation on each connected component of network
     */
  void calculate();
  
  /**
     * Actual Implementation
     * 
     * @param component Connected component of network
     * @param instance Clustering algorithm instance
     * 
     * @return true
     */  
  static bool SSDEComp(map<lui, map <lui, R> >* component, void* instance);
};

#endif